Package com.io7m.jtensors.core.parameterized.vectors

# Class PVector2D<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector2D<T>

Type Parameters:
  `T` - A phantom type parameter

All Implemented Interfaces:
  `PVector2DType<T>`, `PVectorReadable2DType<T>`, `VectorReadable2DType`, `VectorComputationalType`

public final class PVector2D<T> extends Object implements PVector2DType<T>
The type of 2D `double`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `PVector2D.Builder<T>`
  Builds instances of type `PVector2D`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <T> PVector2D.Builder<T>`
  `builder()`
  Creates a builder for `PVector2D`.
  `static <T> PVector2D<T>`
  `copyOf(PVector2DType<T> instance)`
  Creates an immutable copy of a `PVector2DType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `PVector2D` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`.
  `static <T> PVector2D<T>`
  `of(double x, double y)`
  Construct a new immutable `PVector2D` instance.
  `String`
  `toString()`
  Prints the immutable value `PVector2D` with attribute values.
  `final PVector2D<T>`
  `withX(double value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final PVector2D<T>`
  `withY(double value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `double`
  `x()`
  `double`
  `y()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public double x()
    Specified by:
      `x` in interface `PVector2DType<T>`
    Specified by:
      `x` in interface `VectorReadable2DType`
    Returns:
      The value of the `x` attribute

  - ### y

    public double y()
    Specified by:
      `y` in interface `PVector2DType<T>`
    Specified by:
      `y` in interface `VectorReadable2DType`
    Returns:
      The value of the `y` attribute

  - ### withX

    public final PVector2D<T> withX(double value)
    Copy the current immutable object by setting a value for the `x` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final PVector2D<T> withY(double value)
    Copy the current immutable object by setting a value for the `y` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `PVector2D` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `PVector2D` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static <T> PVector2D<T> of(double x, double y)
    Construct a new immutable `PVector2D` instance.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
    Returns:
      An immutable PVector2D instance

  - ### copyOf

    public static <T> PVector2D<T> copyOf(PVector2DType<T> instance)
    Creates an immutable copy of a `PVector2DType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PVector2D instance

  - ### builder

    public static <T> PVector2D.Builder<T> builder()
    Creates a builder for `PVector2D`.

         PVector2D.&lt;T&gt;builder()
            .setX(double) // required x
            .setY(double) // required y
            .build();

    Type Parameters:
      `T` - generic parameter T
    Returns:
      A new PVector2D builder